<template>
  <el-form
    ref="normalBankTransferDepositFormRef"
    status-icon
    label-position="left"
    :model="normalBankTransferDepositFormData"
    :rules="normalBankTransferDepositRules"
    label-width="210px"
    class="py-6 cutomeClass"
    :validate-on-rule-change="false"
  >
  <div class="px-6">
    <div
      v-if="bankTransferDepositTextInfo?.Text.length > 0"
      class="p-4 text-sm rounded bg-background5 --text4 font-normal txt-info"
    >
      <span v-html="bankTransferDepositTextInfo?.Text"></span>
    </div>
    <h4 class="my-4 fc-primary">{{ $t("from") }}</h4>
    <h5 class="--text4">{{ $t("bank") }}</h5>
    <div class="w-full pb-5" v-if="isFirstTimeDeposit">
      <ui-radio-group
        v-model="normalBankTransferDepositFormData.selectedPlayerBankOption"
        group-name="select-bank-name"
        class="flex flex-column flex-wrap gap-2 py-2 select-bank"
      >
        <ui-radio-button
          v-for="player in playerBankOptions"
          :key="player.BankName"
          :label="player.BankName"
          :value="player.BankName"
          active-class="selected"
          class="w-fit h-full"
        >
          <ui-check-button
            v-if="!player.BankLogo || player.BankLogo === undefined"
            variant="ICON_AND_TEXT"
            :text="player.BankName"
          />
          <ui-check-button
            v-else
            style="--height: 3rem"
            :img="getImagePathBankLogo(player.BankLogo)"
          />
        </ui-radio-button>
      </ui-radio-group>
    </div>
    <div class="w-full pb-5" v-else>
      <ui-radio-group
        v-model="normalBankTransferDepositFormData.selectedPlayerBankOption"
        class="flex flex-column flex-wrap gap-3 py-2 select-bank"
      >
        <ui-radio-button
          v-for="(bank, index) in playerBankAfterFirstTimeDeposit"
          :key="index"
          :label="bank.PlayerBankName"
          :value="bank.PlayerBankName"
          active-class="selected"
          class="w-fit h-full"
        >
          <ui-check-button
            v-if="!bank.BankLogo || bank.BankLogo === undefined"
            variant="ICON_AND_TEXT"
            :text="bank.PlayerBankName"
          />
          <ui-check-button
            v-else
            style="--height: 3rem"
            :img="getImagePathBankLogo(bank.BankLogo)"
          />
        </ui-radio-button>
      </ui-radio-group>
    </div>
    <el-form-item
      v-if="
        normalBankTransferDepositFormData.selectedPlayerBankOption === 'Other'
      "
      :label="$t('bank_name')"
      prop="customizeBankName"
    >
      <el-input
        v-model="normalBankTransferDepositFormData.customizeBankName"
        id="depositBankName"
        type="text"
      />
    </el-form-item>
    <el-form-item
      v-if="companyFlowSettings.branchNameSetting"
      :label="$t('BranchName')"
      prop="branchName"
    >
      <el-input
        v-model="normalBankTransferDepositFormData.branchName"
        id="depositBranchName"
        type="text"
      />
    </el-form-item>
    <el-form-item 
      v-if="companyFlowSettings.bankAccountNameSetting"
      :label="$t('bank_account_name')" 
      prop="bankAccountName"
    >
      <el-input
        v-model="normalBankTransferDepositFormData.bankAccountName"
        type="text"
        id="depositBankAccountName"
        :disabled="
          !isFirstTimeDeposit &&
          normalBankTransferDepositFormData.selectedPlayerBankOption !== 'Other' &&
          !isFirstTimeBankAccountNameEmpty
        "
      />
    </el-form-item>
    <el-form-item 
      v-if="companyFlowSettings.bankAccountNumberSetting"
      :label="$t('bank_account_number')" 
      prop="bankAccountNumber"
    >
      <el-input
        v-model="normalBankTransferDepositFormData.bankAccountNumber"
        type="text"
        id="depositBankAccountNumber"
        :disabled="
          !isFirstTimeDeposit &&
          normalBankTransferDepositFormData.selectedPlayerBankOption !== 'Other' &&
          !isFirstTimeBankAccountNumberEmpty
        "
        @input="onInputValue($event, normalBankTransferDepositFormData, 'bankAccountNumber')"
      />
    </el-form-item>
    <el-form-item
      v-if="companyFlowSettings.bsbSetting"
      :label="$t('BSB')"
      prop="bsb"
    >
      <el-input
        maxlength="6"
        v-model="normalBankTransferDepositFormData.bsb" id="depositBSB" 
        @input="onInputValue($event, normalBankTransferDepositFormData, 'bsb')"
      />
    </el-form-item>
    <el-form-item
      v-if="companyFlowSettings.payIdSetting"
      :label="$t('PayID')"
      prop="payId"
    >
      <el-input
        v-model="normalBankTransferDepositFormData.payId" id="depositPayId" 
      />
    </el-form-item>
    <el-form-item :label="$t('amount')" prop="amount">
      <el-input
        v-model="normalBankTransferDepositFormData.amount"
        @input="onInputValue($event, normalBankTransferDepositFormData, 'amount')"
        id="depositAmount"
        :placeholder="amountPlaceholder"
      >
        <template v-if="isNeedToMultiplyByThousand" #append>000</template>
      </el-input>
      <span
        v-if="isNeedToMultiplyByThousand"
        class="order-1 mt-3 text-xs fc-hint"
        >{{
          $t(
            `deposit_amount_shown_by_the_system_${profile.Currency.toLowerCase()}`
          )
        }}</span
      >
    </el-form-item>
    <el-form-item
      v-if="companyFlowSettings.slipUploadSetting"
      :label="$t('slip_image')"
      prop="slipUpload"
    >
      <el-upload
        ref="uploadSlipImageFRef"
        v-model="normalBankTransferDepositFormData.slipUpload"
        class="w-full upload-demo"
        :limit="1"
        :on-exceed="handleSlipImageExceed"
        accept=".jpg, .png, .jpeg, .svg"
        :on-change="getSlipImage"
        :on-remove="removeSlipImage"
        :auto-upload="false"
        id="depositSlipUpload"
      >
        <el-button plain round type="primary" class="!py-2 !px-4">
          {{ $t("choose_file") }}
        </el-button>
      </el-upload>
    </el-form-item>
    <el-form-item
      v-if="companyFlowSettings.depositTimeSetting"
      class="input-class"
      :label="$t('deposit_time')"
      prop="depositTime"
    >
      <el-date-picker
        v-model="normalBankTransferDepositFormData.depositTime"
        id="depositTime"
        type="datetime"
        format="YYYY-MM-DD h:mm:ss A"
      />
    </el-form-item>
    <el-form-item
      v-if="companyFlowSettings.depositReferenceNumberSetting"
      :label="$t('reference_number')"
      prop="depositReferenceNumber"
    >
      <el-input
        v-model="normalBankTransferDepositFormData.depositReferenceNumber"
        id="depositReferenceNo"
        type="text"
        :placeholder="$t('please_enter_your_reference_numbers')"
      />
      <span
        v-if="selectedTheme === 'black'"
        class="order-1 mt-3 text-xs fc-hint"
        >{{ $t("reference_number_remark") }}</span
      >
    </el-form-item>
  </div>
  <div class="px-6 pt-6 border-t-2 border-[var(--border)]">
    <h4 class="mb-4 fc-primary">{{ $t("to company bank") }}</h4>
    <!-- <h5 class="--text4">{{ $t("company_bank") }}</h5> -->
    <div class="pb-5">
      <ui-radio-group
        v-model="selectedCompanyBankId"
        class="flex flex-column flex-wrap gap-2 select-bank"
        group-name="select-company-bank-name"
      >
        <ui-radio-button
          v-for="companyBank in CompanyBanks"
          :key="companyBank.Id"
          :label="companyBank.Id"
          :value="companyBank.Id"
          active-class="selected"
          class="w-fit h-full"
        >
          <ui-check-button
            v-if="!companyBank.BankLogo || companyBank.BankLogo === undefined"
            variant="ICON_AND_TEXT"
            :text="companyBank.BankName"
          />
          <ui-check-button
            v-else
            :img="getImagePathBankLogo(companyBank.BankLogo)"
            style="--height: 3rem"
          />
        </ui-radio-button>
      </ui-radio-group>
    </div>
    <el-form-item
      v-if="companyFlowSettings.companyBankAccountNameSetting"
      :label="$t('CompanyBankAccountName')"
      prop="companyBankAccountName"
      class="isDisabled-container"
    >
      <el-input
        v-model="normalBankTransferDepositFormData.companyBankAccountName"
        id="depositCompanyBankAccountName"
        type="text"
        :disabled="true"
      />
    </el-form-item>
    <el-form-item
      :label="$t('bank_account')"
      prop="companyBankAccountNumber"
      class="company-bank-account company-bank-account-container isDisabled-container"
    >
      <el-input
        v-model="normalBankTransferDepositFormData.companyBankAccountNumber"
        type="text"
        id="depositCompanyBankAccountNumber"
        :disabled="true"
      >
        <template #append>
          <el-button
            :type="isMainOrangeEnabled ? 'secondary' : 'primary'"
            plain
            @click="
              copyTextToClipBoard(
                normalBankTransferDepositFormData.companyBankAccountNumber
              )
            "
          >
            {{ $t("copy") }}
          </el-button>
        </template>
      </el-input>
    </el-form-item>
    <div class="mt-10 text-center submit-wrapper">
      <el-button
        v-if="isUploadImage"
        type="primary"
        :disabled="isUploadImage"
        round
        @click="submitDepositBankTransfer(normalBankTransferDepositFormRef)"
        >{{ $t("waiting_upload_image") }}</el-button
      >
      <el-button
        v-else-if="isProccesing"
        type="primary"
        :disabled="isProccesing"
        round
        @click="submitDepositBankTransfer(normalBankTransferDepositFormRef)"
        >{{ $t("submit") }}</el-button
      >
      <el-button
        v-else
        type="primary"
        round
        @click="submitDepositBankTransfer(normalBankTransferDepositFormRef)"
        >{{ $t("submit") }}</el-button
      >
    </div>
  </div>
  </el-form>
</template>
<script lang="ts">
import { computed, defineComponent, PropType, toRefs } from "vue";
import { IGetTransactionBankListResponse } from "@/models/getTransactionBankListResponse";
import commonHelper from "@/utils/commonHelper";
import { ProfileDto } from "@/models/getProfileResponse";
import themePropertyHelper from "@/utils/themePropertyHelper";
import depositBankImageHelper from "@/utils/depositBankImageHelper";

import { store } from "@/store";
import { isEmpty } from "lodash";

export default defineComponent({
  props: {
    normalBanks: {
      type: Object as PropType<IGetTransactionBankListResponse>,
      required: true,
      default: {} as IGetTransactionBankListResponse,
    },
    profile: {
      type: Object as PropType<ProfileDto>,
      required: true,
      default: {} as ProfileDto,
    },
  },
  setup(props) {
    const { normalBanks, profile } = toRefs(props);
    const {
      getSlipImage,
      removeSlipImage,
      uploadSlipImageFRef,
      copyTextToClipBoard,
      handleSlipImageExceed,
      onInputValue,
      allowCompany,
    } = commonHelper;
    const { themeColor } = themePropertyHelper;
    const { getImagePathBankLogo } = depositBankImageHelper;
    const isMainOrangeEnabled = computed(
      (): boolean => themeColor.value.Text === "main_orange"
    );
    const selectedTheme = computed(() => store.state.selectedThemeName);
    const {
      selectedCompanyBankId,
      companyFlowSettings,
      isFirstTimeDeposit,
      playerBankOptions,
      CompanyBanks,
      playerBankAfterFirstTimeDeposit,
      normalBankTransferDepositRules,
      normalBankTransferDepositFormRef,
      normalBankTransferDepositFormData,
      slipUpload,
      isNeedToMultiplyByThousand,
      isProccesing,
      isUploadImage,
      submitDepositBankTransfer,
      amountPlaceholder,
      bankTransferDepositTextInfo,
      isFirstTimeBankAccountNameEmpty,
      isFirstTimeBankAccountNumberEmpty
    } = useNormalBankTransferDeposit(normalBanks, profile);
    const data = {
      selectedCompanyBankId,
      companyFlowSettings,
      isFirstTimeDeposit,
      playerBankOptions,
      CompanyBanks,
      playerBankAfterFirstTimeDeposit,
      normalBankTransferDepositRules,
      normalBankTransferDepositFormRef,
      normalBankTransferDepositFormData,
      submitDepositBankTransfer,
      copyTextToClipBoard,
      handleSlipImageExceed,
      uploadSlipImageFRef,
      getSlipImage,
      slipUpload,
      removeSlipImage,
      isNeedToMultiplyByThousand,
      isProccesing,
      isUploadImage,
      amountPlaceholder,
      bankTransferDepositTextInfo,
      profile,
      isMainOrangeEnabled,
      selectedTheme,
      getImagePathBankLogo,
      onInputValue,
      allowCompany,
      isFirstTimeBankAccountNameEmpty,
      isFirstTimeBankAccountNumberEmpty
    };
    return data;
  },
});
</script>

<style lang="scss">
.bank-icon :deep(.el-radio-button__inner) {
  background: white;
}
.ui-radio-group.select-bank {
  .check-btn__img {
    min-width: max-content;
    max-height: 32px;
    img {
      max-height: 32px;
    }
  }
  .selected .check-btn__content {
    --content-padding: 0.5rem 2.5rem 0.5rem 1rem;
  }
  .check-btn__content {
    --content-padding: 0.5rem 1rem 0.5rem 1rem;
  }
  @media screen and (max-width: 639px) {
    .check-btn__img {
      display: block;
    }
  }
}
.txt-info {
  word-break: break-word;
}
.submit-wrapper {
  .el-button {
    width: 120px;
    padding: 8px 16px;
  }
}
</style>
